{-# OPTIONS_GHC -w #-}
{-# OPTIONS -fglasgow-exts -cpp #-}
{-# LANGUAGE OverloadedStrings, BangPatterns, NoMonomorphismRestriction, ScopedTypeVariables #-}
module Data.STAR.Parser(parse, parseFile,
                               parsePlainFile,
                               parseCompressedFile) where

import qualified Data.STAR.Tokens as Tokens

import Control.Monad(liftM, liftM2)
import Control.Monad.State.Strict
import qualified Data.STAR.Type as Type
import Prelude hiding (String, getContents, drop, take, (++))
import Data.ByteString.Char8    as BSC
import Control.DeepSeq
import qualified Control.Exception as Exc -- (SomeException, catch)
import qualified GHC.Exts as Happy_GHC_Exts
import Data.STAR.StringUtil
import qualified Data.List(isSuffixOf, (++))
import qualified Data.Array as Happy_Data_Array
import qualified GHC.Exts as Happy_GHC_Exts

-- parser produced by Happy Version 1.19.3

newtype HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 = HappyAbsSyn HappyAny
#if __GLASGOW_HASKELL__ >= 607
type HappyAny = Happy_GHC_Exts.Any
#else
type HappyAny = forall a . a
#endif
happyIn4 :: ([Type.STARBlock]) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn4 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn4 #-}
happyOut4 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> ([Type.STARBlock])
happyOut4 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut4 #-}
happyIn5 :: (Type.STARBlock) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn5 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn5 #-}
happyOut5 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (Type.STARBlock)
happyOut5 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut5 #-}
happyIn6 :: (Type.STAREntry) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn6 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn6 #-}
happyOut6 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (Type.STAREntry)
happyOut6 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut6 #-}
happyIn7 :: (Type.STAREntry) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn7 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn7 #-}
happyOut7 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (Type.STAREntry)
happyOut7 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut7 #-}
happyIn8 :: (Type.STAREntry) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn8 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn8 #-}
happyOut8 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (Type.STAREntry)
happyOut8 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut8 #-}
happyIn9 :: (Type.STARKey -> Type.STAREntry) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (Type.STARKey -> Type.STAREntry)
happyOut9 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyIn10 :: (Type.String) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn10 #-}
happyOut10 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (Type.String)
happyOut10 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut10 #-}
happyIn11 :: (Type.STAREntry) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn11 #-}
happyOut11 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (Type.STAREntry)
happyOut11 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut11 #-}
happyIn12 :: ([STARType]) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn12 #-}
happyOut12 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> ([STARType])
happyOut12 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut12 #-}
happyIn13 :: (STARType) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn13 #-}
happyOut13 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (STARType)
happyOut13 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut13 #-}
happyIn14 :: ([STARStruct]) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn14 #-}
happyOut14 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> ([STARStruct])
happyOut14 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut14 #-}
happyIn15 :: (STARStruct) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn15 #-}
happyOut15 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (STARStruct)
happyOut15 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut15 #-}
happyIn16 :: t16 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn16 #-}
happyOut16 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t16
happyOut16 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut16 #-}
happyIn17 :: t17 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn17 #-}
happyOut17 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t17
happyOut17 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut17 #-}
happyIn18 :: t18 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn18 #-}
happyOut18 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t18
happyOut18 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut18 #-}
happyIn19 :: t19 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn19 #-}
happyOut19 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t19
happyOut19 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut19 #-}
happyIn20 :: t20 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn20 #-}
happyOut20 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t20
happyOut20 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut20 #-}
happyIn21 :: t21 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn21 #-}
happyOut21 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t21
happyOut21 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut21 #-}
happyIn22 :: t22 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn22 #-}
happyOut22 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t22
happyOut22 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut22 #-}
happyIn23 :: t23 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn23 #-}
happyOut23 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t23
happyOut23 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut23 #-}
happyIn24 :: t24 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn24 #-}
happyOut24 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t24
happyOut24 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut24 #-}
happyIn25 :: t25 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn25 #-}
happyOut25 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t25
happyOut25 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut25 #-}
happyIn26 :: t26 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn26 #-}
happyOut26 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t26
happyOut26 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut26 #-}
happyIn27 :: t27 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn27 #-}
happyOut27 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t27
happyOut27 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut27 #-}
happyIn28 :: t28 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn28 #-}
happyOut28 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t28
happyOut28 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut28 #-}
happyIn29 :: t29 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn29 #-}
happyOut29 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t29
happyOut29 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut29 #-}
happyIn30 :: t30 -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyIn30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn30 #-}
happyOut30 :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> t30
happyOut30 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut30 #-}
happyInTok :: (Tokens.Token) -> (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30)
happyInTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30) -> (Tokens.Token)
happyOutTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOutTok #-}


happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\x44\x00\x44\x00\x00\x00\x00\x00\x3c\x00\x43\x00\x2c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1d\x00\x42\x00\x00\x00\x00\x00\x00\x00\x3c\x00\x00\x00\x44\x00\x00\x00\x32\x00\x00\x00\x3c\x00\x00\x00\x1a\x00\x00\x00\x42\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\x00\x00\x00\x41\x00\x00\x00\x00\x00\x1b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x3b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1a\x00\x00\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\x01\x00\x0a\x00\x23\x00\x00\x00\x0e\x00\x10\x00\x00\x00\x1f\x00\x00\x00\x00\x00\x00\x00\x14\x00\x1c\x00\x1e\x00\x00\x00\x00\x00\x02\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x26\x00\x18\x00\x12\x00\x00\x00\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x37\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf2\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xfa\xff\x00\x00\x00\x00\x00\x00\x00\x00\x28\x00\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\x00\x00\x00\x00\xde\xff\xfe\xff\x00\x00\x00\x00\x00\x00\xda\xff\xf9\xff\xf8\xff\xfd\xff\x00\x00\x00\x00\xdc\xff\xfb\xff\xfc\xff\x00\x00\xe9\xff\xe4\xff\xdf\xff\x00\x00\xe8\xff\xe3\xff\xd8\xff\x00\x00\xf0\xff\x00\x00\xf7\xff\xf4\xff\xf6\xff\xf5\xff\x00\x00\xe7\xff\xe2\xff\xdb\xff\xf3\xff\x00\x00\xea\xff\xd6\xff\xf2\xff\xed\xff\xeb\xff\xec\xff\xe6\xff\xe1\xff\xdd\xff\xfa\xff\xd9\xff\xe5\xff\xe0\xff\xef\xff\xd7\xff"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x00\x00\x01\x00\x09\x00\x02\x00\x03\x00\x04\x00\x15\x00\x09\x00\x07\x00\x01\x00\x01\x00\x1a\x00\x0c\x00\x0f\x00\x0d\x00\x02\x00\x03\x00\x04\x00\x03\x00\x04\x00\x07\x00\x0c\x00\x07\x00\x06\x00\x05\x00\x06\x00\x0d\x00\x02\x00\x0b\x00\x0e\x00\x02\x00\x06\x00\x06\x00\x10\x00\x09\x00\x0a\x00\x09\x00\x09\x00\x0a\x00\x02\x00\x03\x00\x04\x00\x0f\x00\x14\x00\x07\x00\x06\x00\x0b\x00\x12\x00\x19\x00\x13\x00\x0b\x00\x11\x00\x17\x00\x04\x00\x18\x00\x0c\x00\x16\x00\x03\x00\x04\x00\x01\x00\x01\x00\x07\x00\x03\x00\x05\x00\x05\x00\x01\x00\x01\x00\x01\x00\xff\xff\x05\x00\x05\x00\x05\x00\xff\xff\xff\xff\x07\x00\x08\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\x06\x00\x02\x00\x2f\x00\x0d\x00\x0e\x00\x08\x00\x30\x00\x17\x00\x09\x00\x13\x00\x02\x00\x31\x00\x03\x00\x24\x00\x14\x00\x0d\x00\x0e\x00\x08\x00\x07\x00\x08\x00\x09\x00\x03\x00\x09\x00\x25\x00\x1b\x00\x1c\x00\x0f\x00\x29\x00\x26\x00\x0a\x00\x1e\x00\x2a\x00\x33\x00\x27\x00\x2b\x00\x20\x00\x17\x00\x1f\x00\x20\x00\x2d\x00\x0e\x00\x08\x00\x18\x00\x2b\x00\x09\x00\x25\x00\x24\x00\x15\x00\x2c\x00\x20\x00\x33\x00\x11\x00\x16\x00\x2f\x00\x21\x00\xff\xff\x12\x00\x22\x00\x08\x00\x1a\x00\x0c\x00\x09\x00\x11\x00\x1b\x00\x0d\x00\x0c\x00\x1a\x00\x0c\x00\x00\x00\x0d\x00\x1b\x00\x0d\x00\x00\x00\x00\x00\x05\x00\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = Happy_Data_Array.array (1, 41) [
	(1 , happyReduce_1),
	(2 , happyReduce_2),
	(3 , happyReduce_3),
	(4 , happyReduce_4),
	(5 , happyReduce_5),
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34),
	(35 , happyReduce_35),
	(36 , happyReduce_36),
	(37 , happyReduce_37),
	(38 , happyReduce_38),
	(39 , happyReduce_39),
	(40 , happyReduce_40),
	(41 , happyReduce_41)
	]

happy_n_terms = 13 :: Int
happy_n_nonterms = 27 :: Int

happyReduce_1 = happySpecReduce_1  0# happyReduction_1
happyReduction_1 happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	happyIn4
		 (happy_var_1
	)}

happyReduce_2 = happySpecReduce_2  1# happyReduction_2
happyReduction_2 happy_x_2
	happy_x_1
	 =  case happyOut18 happy_x_2 of { happy_var_2 -> 
	happyIn5
		 (Type.Global happy_var_2
	)}

happyReduce_3 = happySpecReduce_2  1# happyReduction_3
happyReduction_3 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut17 happy_x_2 of { happy_var_2 -> 
	happyIn5
		 (Type.Data (Tokens.tokenValue happy_var_1) happy_var_2
	)}}

happyReduce_4 = happySpecReduce_1  2# happyReduction_4
happyReduction_4 happy_x_1
	 =  case happyOut7 happy_x_1 of { happy_var_1 -> 
	happyIn6
		 (happy_var_1
	)}

happyReduce_5 = happySpecReduce_3  2# happyReduction_5
happyReduction_5 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut17 happy_x_2 of { happy_var_2 -> 
	happyIn6
		 (Type.Frame (Tokens.tokenValue happy_var_1) happy_var_2
	)}}

happyReduce_6 = happySpecReduce_1  3# happyReduction_6
happyReduction_6 happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	happyIn7
		 (happy_var_1
	)}

happyReduce_7 = happySpecReduce_1  3# happyReduction_7
happyReduction_7 happy_x_1
	 =  case happyOut11 happy_x_1 of { happy_var_1 -> 
	happyIn7
		 (happy_var_1
	)}

happyReduce_8 = happySpecReduce_2  4# happyReduction_8
happyReduction_8 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOut9 happy_x_2 of { happy_var_2 -> 
	happyIn8
		 (let t = Tokens.tokenValue happy_var_1 in t `seq` happy_var_2 (Tokens.tokenValue happy_var_1)
	)}}

happyReduce_9 = happySpecReduce_1  5# happyReduction_9
happyReduction_9 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn9
		 (let t = Tokens.tokenValue happy_var_1 in t `seq` \k -> Type.Entry k t
	)}

happyReduce_10 = happySpecReduce_1  5# happyReduction_10
happyReduction_10 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn9
		 (let t = Tokens.tokenValue happy_var_1 in t `seq` \k -> Type.Ref   k t
	)}

happyReduce_11 = happySpecReduce_1  5# happyReduction_11
happyReduction_11 happy_x_1
	 =  case happyOut10 happy_x_1 of { happy_var_1 -> 
	happyIn9
		 (happy_var_1 `seq` \k -> Type.Entry k happy_var_1
	)}

happyReduce_12 = happySpecReduce_2  6# happyReduction_12
happyReduction_12 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { happy_var_2 -> 
	happyIn10
		 (cheatConcat (Tokens.tokenValue happy_var_1) (Tokens.tokenValue happy_var_2)
	)}}

happyReduce_13 = happyMonadReduce 3# 7# happyReduction_13
happyReduction_13 (happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut19 happy_x_2 of { happy_var_2 -> 
	case happyOut20 happy_x_3 of { happy_var_3 -> 
	( matchTypesValues happy_var_2 happy_var_3)}}
	) (\r -> happyReturn (happyIn11 r))

happyReduce_14 = happySpecReduce_1  8# happyReduction_14
happyReduction_14 happy_x_1
	 =  case happyOut19 happy_x_1 of { happy_var_1 -> 
	happyIn12
		 (happy_var_1
	)}

happyReduce_15 = happySpecReduce_1  9# happyReduction_15
happyReduction_15 happy_x_1
	 =  case happyOutTok happy_x_1 of { happy_var_1 -> 
	happyIn13
		 (TSimple  (Tokens.tokenValue happy_var_1)
	)}

happyReduce_16 = happySpecReduce_3  9# happyReduction_16
happyReduction_16 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut19 happy_x_2 of { happy_var_2 -> 
	happyIn13
		 (TComplex happy_var_2
	)}

happyReduce_17 = happySpecReduce_1  10# happyReduction_17
happyReduction_17 happy_x_1
	 =  case happyOut20 happy_x_1 of { happy_var_1 -> 
	happyIn14
		 (happy_var_1
	)}

happyReduce_18 = happyMonadReduce 1# 11# happyReduction_18
happyReduction_18 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOutTok happy_x_1 of { happy_var_1 -> 
	( addPos $ \p -> SText p $ Tokens.tokenValue happy_var_1)}
	) (\r -> happyReturn (happyIn15 r))

happyReduce_19 = happyMonadReduce 1# 11# happyReduction_19
happyReduction_19 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOutTok happy_x_1 of { happy_var_1 -> 
	( addPos $ \p -> SRef  p $ Tokens.tokenValue happy_var_1)}
	) (\r -> happyReturn (happyIn15 r))

happyReduce_20 = happyMonadReduce 1# 11# happyReduction_20
happyReduction_20 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (( addPos $ \p -> SStop p)
	) (\r -> happyReturn (happyIn15 r))

happyReduce_21 = happyMonadReduce 1# 11# happyReduction_21
happyReduction_21 (happy_x_1 `HappyStk`
	happyRest) tk
	 = happyThen (case happyOut10 happy_x_1 of { happy_var_1 -> 
	( addPos $ \p -> SText p                     happy_var_1)}
	) (\r -> happyReturn (happyIn15 r))

happyReduce_22 = happySpecReduce_2  12# happyReduction_22
happyReduction_22 happy_x_2
	happy_x_1
	 =  case happyOut5 happy_x_1 of { happy_var_1 -> 
	case happyOut21 happy_x_2 of { happy_var_2 -> 
	happyIn16
		 (happy_var_1 `seq` happy_var_1:happy_var_2
	)}}

happyReduce_23 = happySpecReduce_2  13# happyReduction_23
happyReduction_23 happy_x_2
	happy_x_1
	 =  case happyOut6 happy_x_1 of { happy_var_1 -> 
	case happyOut22 happy_x_2 of { happy_var_2 -> 
	happyIn17
		 (happy_var_1 `seq` happy_var_1:happy_var_2
	)}}

happyReduce_24 = happySpecReduce_2  14# happyReduction_24
happyReduction_24 happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_1 of { happy_var_1 -> 
	case happyOut23 happy_x_2 of { happy_var_2 -> 
	happyIn18
		 (happy_var_1 `seq` happy_var_1:happy_var_2
	)}}

happyReduce_25 = happySpecReduce_2  15# happyReduction_25
happyReduction_25 happy_x_2
	happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_2 of { happy_var_2 -> 
	happyIn19
		 (happy_var_1 `seq` happy_var_1:happy_var_2
	)}}

happyReduce_26 = happySpecReduce_2  16# happyReduction_26
happyReduction_26 happy_x_2
	happy_x_1
	 =  case happyOut15 happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	happyIn20
		 (happy_var_1 `seq` happy_var_1:happy_var_2
	)}}

happyReduce_27 = happySpecReduce_1  17# happyReduction_27
happyReduction_27 happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	happyIn21
		 (Prelude.reverse happy_var_1
	)}

happyReduce_28 = happySpecReduce_1  18# happyReduction_28
happyReduction_28 happy_x_1
	 =  case happyOut27 happy_x_1 of { happy_var_1 -> 
	happyIn22
		 (Prelude.reverse happy_var_1
	)}

happyReduce_29 = happySpecReduce_1  19# happyReduction_29
happyReduction_29 happy_x_1
	 =  case happyOut28 happy_x_1 of { happy_var_1 -> 
	happyIn23
		 (Prelude.reverse happy_var_1
	)}

happyReduce_30 = happySpecReduce_1  20# happyReduction_30
happyReduction_30 happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	happyIn24
		 (Prelude.reverse happy_var_1
	)}

happyReduce_31 = happySpecReduce_1  21# happyReduction_31
happyReduction_31 happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	happyIn25
		 (Prelude.reverse happy_var_1
	)}

happyReduce_32 = happySpecReduce_2  22# happyReduction_32
happyReduction_32 happy_x_2
	happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	case happyOut5 happy_x_2 of { happy_var_2 -> 
	happyIn26
		 (happy_var_2:happy_var_1
	)}}

happyReduce_33 = happySpecReduce_0  22# happyReduction_33
happyReduction_33  =  happyIn26
		 ([]
	)

happyReduce_34 = happySpecReduce_2  23# happyReduction_34
happyReduction_34 happy_x_2
	happy_x_1
	 =  case happyOut27 happy_x_1 of { happy_var_1 -> 
	case happyOut6 happy_x_2 of { happy_var_2 -> 
	happyIn27
		 (happy_var_2:happy_var_1
	)}}

happyReduce_35 = happySpecReduce_0  23# happyReduction_35
happyReduction_35  =  happyIn27
		 ([]
	)

happyReduce_36 = happySpecReduce_2  24# happyReduction_36
happyReduction_36 happy_x_2
	happy_x_1
	 =  case happyOut28 happy_x_1 of { happy_var_1 -> 
	case happyOut7 happy_x_2 of { happy_var_2 -> 
	happyIn28
		 (happy_var_2:happy_var_1
	)}}

happyReduce_37 = happySpecReduce_0  24# happyReduction_37
happyReduction_37  =  happyIn28
		 ([]
	)

happyReduce_38 = happySpecReduce_2  25# happyReduction_38
happyReduction_38 happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut13 happy_x_2 of { happy_var_2 -> 
	happyIn29
		 (happy_var_2:happy_var_1
	)}}

happyReduce_39 = happySpecReduce_0  25# happyReduction_39
happyReduction_39  =  happyIn29
		 ([]
	)

happyReduce_40 = happySpecReduce_2  26# happyReduction_40
happyReduction_40 happy_x_2
	happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	case happyOut15 happy_x_2 of { happy_var_2 -> 
	happyIn30
		 (happy_var_2:happy_var_1
	)}}

happyReduce_41 = happySpecReduce_0  26# happyReduction_41
happyReduction_41  =  happyIn30
		 ([]
	)

happyNewToken action sts stk
	= Tokens.getToken(\tk -> 
	let cont i = happyDoAction i tk action sts stk in
	case tk of {
	Tokens.EOF -> happyDoAction 12# tk action sts stk;
	Tokens.Name      _ -> cont 1#;
	Tokens.Text      _ -> cont 2#;
	Tokens.Save      _ -> cont 3#;
	Tokens.EndSave -> cont 4#;
	Tokens.Loop -> cont 5#;
	Tokens.EndLoop -> cont 6#;
	Tokens.Data      _ -> cont 7#;
	Tokens.Global -> cont 8#;
	Tokens.Ref       _ -> cont 9#;
	Tokens.SemiStart _ -> cont 10#;
	Tokens.SemiEnd   _ -> cont 11#;
	_ -> happyError' tk
	})

happyError_ 12# tk = happyError' tk
happyError_ _ tk = happyError' tk

happyThen :: () => Tokens.ParserM a -> (a -> Tokens.ParserM b) -> Tokens.ParserM b
happyThen = (Tokens.parseThen)
happyReturn :: () => a -> Tokens.ParserM a
happyReturn = (Tokens.parseReturn)
happyThen1 = happyThen
happyReturn1 :: () => a -> Tokens.ParserM a
happyReturn1 = happyReturn
happyError' :: () => (Tokens.Token) -> Tokens.ParserM a
happyError' tk = failToken tk

parseSTAR = happySomeParser where
  happySomeParser = happyThen (happyParse 0#) (\x -> happyReturn (happyOut4 x))

happySeq = happyDontSeq


data STARType   = TSimple  Type.STARKey
                | TComplex [STARType]
  deriving (Show, Eq)

data STARStruct = SText Tokens.AlexPosn Type.String -- keep position for matchTypesValues error reporting!
                | SRef  Tokens.AlexPosn Type.String -- TODO: implement!!!
                | SStop Tokens.AlexPosn
  deriving (Show,Eq)

addPos e = do pos <- Tokens.getPos
              return $! e pos

matchTypesValues  :: [STARType] -> [STARStruct] -> Tokens.ParserM Type.STAREntry
matchTypesValues !ts !ss = matchTypesValues' ts ts ss [] [] finish reportError
  where
    finish :: [[Type.STAREntry]] -> [STARStruct] -> Tokens.ParserM Type.STAREntry
    finish entries [] = return $ Type.Loop entries
    reportError msg = Tokens.parseError $ BSC.concat [msg, bshow $ Prelude.zip (infiniteConcat ts) (Prelude.concatMap unText ss)]
    bshow  = BSC.pack . show
    unText (SText _ s) = [s]
    unText (SRef  _ s) = [s]
    unText (SStop _  ) = [ ]
    infiniteConcat ss  = ss Data.List.++ infiniteConcat ss
     

--matchTypesValues' :: [STARType] -> [STARType] -> [STARStruct] -> [[Type.STAREntry]] -> [Type.STAREntry] -> ([[Type.STAREntry]] -> [STARStruct] -> a) -> a
matchTypesValues' (TSimple  t :ts) tts (SText p  s:ss) !acc1 !acc2 !cont !errCont = matchTypesValues' ts  tts ss acc1 (Type.Entry t s:acc2) cont     errCont
matchTypesValues' (TSimple  t :ts) tts (SRef  p  s:ss) !acc1 !acc2 !cont !errCont = matchTypesValues' ts  tts ss acc1 (Type.Ref   t s:acc2) cont     errCont
matchTypesValues' (TComplex tc:ts) tts ss              !acc1 !acc2 !cont !errCont = matchTypesValues' tc  tc  ss []   []                    loopCont errCont
  where
    --loopCont :: [Type.STAREntry] -> [STARStruct] -> a
    loopCont es sn = matchTypesValues' ts tts sn acc1 (Type.Loop es:acc2) cont errCont
matchTypesValues' []               tts (SStop p :ss) !acc1 !acc2 !cont !errCont = cont (Prelude.reverse (Prelude.reverse acc2:acc1)) ss
matchTypesValues' []               tts ss            !acc1 !acc2 !cont !errCont = matchTypesValues' tts tts ss (Prelude.reverse acc2:acc1) [] cont errCont
matchTypesValues' (t          :_ ) _   (s       :ss) !acc1 !acc2 !cont !errCont = errCont $ BSC.pack $ Prelude.concat ["Can't match declared ",
                                                                                                                       show t,
                                                                                                                       " and actual ",
                                                                                                                       show s]

failToken tok = Tokens.parseError . BSC.concat $ ["parse error on ", BSC.pack $ show tok]

parse = Tokens.runParser parseSTAR

parsePlainFile fname = parseFileCompressed False fname
parseFileCompressed isCompressed fname = (do r <- reader fname
                                             case parse r of
                                               Left  (Tokens.ParseError l c st s) -> return $ Left $ Prelude.concat ["Parse error in line ", show l,
                                                                                                                     " column ", show c,
                                                                                                                     ":", BSC.unpack s,
                                                                                                                     "(lexer state is ", show st, ")"]
                                                                                       
                                               Right result                       -> return $ Right $ Type.STAR result
                                         ) `Exc.catch` handler
  where reader = if isCompressed
                   then compressedRead
                   else simpleRead
        handler (e :: Exc.SomeException) = return . Left . Prelude.concat $ ["Error in ", fname, ": ", show e]

parseCompressedFile fname = parseFileCompressed True fname

parseFile fname =  parseFileCompressed (".gz" `Data.List.isSuffixOf` fname) fname
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 8 "<command-line>" #-}
# 1 "/usr/include/stdc-predef.h" 1 3 4

# 17 "/usr/include/stdc-predef.h" 3 4










































{-# LINE 8 "<command-line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 13 "templates/GenericTemplate.hs" #-}





-- Do not remove this comment. Required to fix CPP parsing when using GCC and a clang-compiled alex.
#if __GLASGOW_HASKELL__ > 706
#define LT(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.<# m)) :: Bool)
#define GTE(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.>=# m)) :: Bool)
#define EQ(n,m) ((Happy_GHC_Exts.tagToEnum# (n Happy_GHC_Exts.==# m)) :: Bool)
#else
#define LT(n,m) (n Happy_GHC_Exts.<# m)
#define GTE(n,m) (n Happy_GHC_Exts.>=# m)
#define EQ(n,m) (n Happy_GHC_Exts.==# m)
#endif
{-# LINE 46 "templates/GenericTemplate.hs" #-}


data Happy_IntList = HappyCons Happy_GHC_Exts.Int# Happy_IntList





{-# LINE 67 "templates/GenericTemplate.hs" #-}

{-# LINE 77 "templates/GenericTemplate.hs" #-}

{-# LINE 86 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
        happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
        (happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
        = {- nothing -}


          case action of
                0#           -> {- nothing -}
                                     happyFail i tk st
                -1#          -> {- nothing -}
                                     happyAccept i tk st
                n | LT(n,(0# :: Happy_GHC_Exts.Int#)) -> {- nothing -}

                                                   (happyReduceArr Happy_Data_Array.! rule) i tk st
                                                   where rule = (Happy_GHC_Exts.I# ((Happy_GHC_Exts.negateInt# ((n Happy_GHC_Exts.+# (1# :: Happy_GHC_Exts.Int#))))))
                n                 -> {- nothing -}


                                     happyShift new_state i tk st
                                     where new_state = (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#))
   where off    = indexShortOffAddr happyActOffsets st
         off_i  = (off Happy_GHC_Exts.+# i)
         check  = if GTE(off_i,(0# :: Happy_GHC_Exts.Int#))
                  then EQ(indexShortOffAddr happyCheck off_i, i)
                  else False
         action
          | check     = indexShortOffAddr happyTable off_i
          | otherwise = indexShortOffAddr happyDefActions st


indexShortOffAddr (HappyA# arr) off =
        Happy_GHC_Exts.narrow16Int# i
  where
        i = Happy_GHC_Exts.word2Int# (Happy_GHC_Exts.or# (Happy_GHC_Exts.uncheckedShiftL# high 8#) low)
        high = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr (off' Happy_GHC_Exts.+# 1#)))
        low  = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr off'))
        off' = off Happy_GHC_Exts.*# 2#





data HappyAddr = HappyA# Happy_GHC_Exts.Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)

{-# LINE 170 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) sts of
         sts1@((HappyCons (st1@(action)) (_))) ->
                let r = fn stk in  -- it doesn't hurt to always seq here...
                happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
          let drop_stk = happyDropStk k stk in
          happyThen1 (fn stk tk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))

happyMonad2Reduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
      case happyDrop k (HappyCons (st) (sts)) of
        sts1@((HappyCons (st1@(action)) (_))) ->
         let drop_stk = happyDropStk k stk

             off = indexShortOffAddr happyGotoOffsets st1
             off_i = (off Happy_GHC_Exts.+# nt)
             new_state = indexShortOffAddr happyTable off_i



          in
          happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))

happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n Happy_GHC_Exts.-# (1#::Happy_GHC_Exts.Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off = indexShortOffAddr happyGotoOffsets st
         off_i = (off Happy_GHC_Exts.+# nt)
         new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail 0# tk old_st _ stk@(x `HappyStk` _) =
     let i = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--      trace "failing" $ 
        happyError_ i tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
                                                (saved_tok `HappyStk` _ `HappyStk` stk) =
--      trace ("discarding state, depth " ++ show (length stk))  $
        happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
        happyDoAction 0# tk action sts ( (Happy_GHC_Exts.unsafeCoerce# (Happy_GHC_Exts.I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Happy_GHC_Exts.Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--      happySeq = happyDoSeq
-- otherwise it emits
--      happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
